using System;
using System.Collections.Generic;
using System.Text;

namespace Converters
{
    public interface IParameter
    {
        string FormalParameter { get; set; }
        string EffectiveParameter { get; set; }
        bool IsMutableParameter { get; set; }
    }

    public interface IFunction
    {
        string Name { get; set; }
        List<IParameter> Parameters { get; }
        List<string> LocalVariables { get; }
        int IndentSize { get; set; }
        string Source { get; set; }
        string CacheSource { get; set; }
        string AdditionalSource { get; set; }
        List<string> UsedVariables { get; }
        void AddToSource(string source);
    }

    public interface ICodeConverter
    {
        string LanguageName { get; }
        string FunctionsFileName { get; set; }
        string PrincipalFileName { get; set; }
        List<IFunction> ImplementedFunctions { get; }
        List<IFunction> CallingFunctions { get; }
        IFunction Main { get; }
        IFunction CurrentFunction { get; set; }
        void Convert(ILanguageConverter obj);
        void PushFunction(IFunction function);
        IFunction PopFunction();
        void WriteToFile(string fileDict, string fileName);
    }
}
