using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Xml;

namespace o2Mate
{
    [Guid("02043462-E52F-477a-BF12-F74B6D215057")]
    [CoClass(typeof(IArray))]
    [InterfaceType(ComInterfaceType.InterfaceIsIDispatch)]
    public interface IArray
    {
        Object Item(int index);
        int Count { get; }
        void Add(Object fields);
        void Load(XmlNode node);
        XmlNodeList Save(XmlDocument doc);
    }

    [ClassInterface(ClassInterfaceType.None)]
    public class Array : IArray
    {
        #region Private Fields
        List<Fields> list;
        #endregion

        #region Default Constructor
        public Array()
        {
            this.list = new List<Fields>();
        }
        #endregion

        #region IArray Membres

        public object Item(int index)
        {
            // compatibilit avec la version VB6
            return this.list[index - 1];
        }

        public int Count
        {
            get { return this.list.Count; }
        }

        public void Add(object fields)
        {
            this.list.Add(fields as Fields);
        }

        public void Load(XmlNode node)
        {
            XmlNodeList nodes = node.SelectNodes("item");
            if (nodes != null)
            {
                foreach (XmlNode item in nodes)
                {
                    Fields f = new Fields();
                    f.Load(item);
                    this.list.Add(f);
                }
            }
        }

        public XmlNodeList Save(XmlDocument doc)
        {
            XmlNode root = doc.CreateElement("root");
            foreach (Fields item in this.list)
            {
                XmlNode node = item.Save(doc);
                root.AppendChild(node);
            }
            return root.ChildNodes;
        }

        #endregion
    }
}
