using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;
using System.Windows.Forms;
using Converters;

namespace o2Mate
{
    public interface Compiler
    {
        string TypeName { get; }
        void ExtractDictionary(IProcess proc);
        void Load(ICompilateur comp, XmlNode node);
        void Inject(Compiler obj, ICompilateur comp, XmlNode node, string modifier);
        void Display(HtmlDocument doc, Node<Compiler> node, bool forcedIndent, ref int indent);
        void DisplayReadOnly(HtmlDocument doc, Node<Compiler> node, bool forcedIndent, ref int indent);
        void Update(HtmlElement doc);
        void Save(ICompilateur comp, XmlWriter writer, ref HtmlElement child);
        void Parse(ICompilateur comp, XmlNode node);
        void WriteToFile(IProcess proc, FinalFile file);
        void Convert(ICodeConverter converter, IProcess proc, FinalFile file);
    }
}
