using System;
using System.Collections.Generic;
using System.Text;

namespace o2Mate
{
    internal class Locale : Compiler
    {
        #region Private Fields
        private string localeName;
        #endregion

        #region Compiler Membres

        public string TypeName
        {
            get { return "Locale"; }
        }

        public void ExtractDictionary(IProcess proc)
        {
        }

        public void Inject(Compiler obj, ICompilateur comp, System.Xml.XmlNode node, string modifier)
        {
            this.Load(comp, node);
        }

        public void Load(ICompilateur comp, System.Xml.XmlNode node)
        {
            this.localeName = node.InnerText;
        }

        public void Display(System.Windows.Forms.HtmlDocument doc, Node<Compiler> node, bool forcedIndent, ref int indent)
        {
        }

        public void DisplayReadOnly(System.Windows.Forms.HtmlDocument doc, Node<Compiler> node, bool forcedIndent, ref int indent)
        {
        }

        public void Update(System.Windows.Forms.HtmlElement doc)
        {
        }

        public void Save(ICompilateur comp, System.Xml.XmlWriter writer, ref System.Windows.Forms.HtmlElement child)
        {
            writer.WriteStartElement("locale");
            writer.WriteString(this.localeName);
            writer.WriteEndElement();
        }

        public void Parse(ICompilateur comp, System.Xml.XmlNode node)
        {
            this.localeName = node.InnerText;
        }

        public void WriteToFile(IProcess proc, FinalFile file)
        {
            if (proc.CurrentScope.Exists(proc.DefaultWriter))
            {
                string writer = proc.CurrentScope.GetVariable(proc.DefaultWriter).ValueString;
                o2Mate.LocaleGroup lg = new LocaleGroup();
                string groupName;
                string title;
                if (lg.ExtractGroupAndName(this.localeName, out groupName, out title))
                {
                    ILocaleSet set = lg.Get(groupName) as ILocaleSet;
                    string language = System.Threading.Thread.CurrentThread.CurrentUICulture.Name;
                    try
                    {
                        // lve une exception si l'lement n'existe pas
                        FinalFile.WriteToFile(ref writer, set.Get(title, language));
                    }
                    catch
                    {
                        FinalFile.WriteToFile(ref writer, this.localeName);
                    }
                }
                proc.CurrentScope.GetVariable(proc.DefaultWriter).Value = writer;
            }

        }

        public void Convert(Converters.ICodeConverter converter, IProcess proc, FinalFile file)
        {
        }

        #endregion
    }
}
