using System;
using System.Collections.Generic;
using System.Text;

namespace o2Mate
{
    public class Skeleton
    {
        #region Private Fields
        private Node<Compiler> node;
        private Process process;
        private LegendeDict legendes;
        private string path;
        private string name;
        #endregion

        #region Default Constructor
        internal Skeleton(string path, string name)
        {
            this.process = null;
            this.legendes = null;
            this.node = null;
            this.path = path;
            this.name = name;
        }
        #endregion

        #region Public Properties
        public string Path
        {
            get
            {
                return this.path;
            }
        }

        public string Name
        {
            get
            {
                return this.name;
            }
        }
        #endregion

        #region Internal Properties
        internal Process Process
        {
            get { return this.process; }
            set { this.process = value; }
        }

        internal Node<Compiler> Objects
        {
            get { return this.node; }
            set { this.node = value; }
        }

        internal LegendeDict Legendes
        {
            get { return this.legendes; }
            set { this.legendes = value; }
        }
        #endregion
    }
}
