using System;
using System.Collections.Generic;
using System.Text;

namespace o2Mate
{
    public class Leaf<T> : List<Node<T>>
    {
        #region Private Fields
        T _obj;
        #endregion

        #region Public Properties
        public T Object
        {
            get { return this._obj; }
            set { this._obj = value; }
        }
        #endregion
    }

    public class Node<T> : Leaf<T>
    {
        #region Private Fields
        Node<T> _subNode;
        #endregion

        #region Public Constructor
        public Node()
        {
            // deprecated
            this._subNode = null;
        }
        #endregion

        #region Public Properties
        // deprecated
        public Node<T> SubNode
        {
            get
            {
                if (this._subNode == null)
                    this._subNode = new Node<T>();
                return this._subNode;
            }
        }
        #endregion
    }

    public class Tree<T>
    {
        #region Private Fields
        Stack<Node<T>> _parents;
        Node<T> _root;
        Node<T> _current;
        Node<T> _lastNode;
        #endregion

        #region Public Constructor
        public Tree()
        {
            this._parents = new Stack<Node<T>>();
            this._root = new Node<T>();
            this._current = this._root;
            this._lastNode = null;
        }

        public Tree(Node<T> node)
        {
            this._parents = new Stack<Node<T>>();
            this._root = node;
            this._current = this._root;
            this._lastNode = null;
        }
        #endregion

        #region Public Properties
        public Node<T> Current
        {
            get { return this._current; }
        }

        public int RootCount
        {
            get { return this._root.Count; }
        }

        public Node<T> Last
        {
            get { return this._lastNode; }
        }
        #endregion

        #region Public Methods
        public List<Node<T>>.Enumerator GetEnumerator()
        {
            return this._root.GetEnumerator();
        }

        public void Add(T obj)
        {
            Node<T> node = new Node<T>();
            node.Object = obj;
            this._lastNode = node;
            this._current.Add(node);
        }

        public void Push()
        {
            this._parents.Push(this._current);
            this._current = this._lastNode;
            this._lastNode = null;
        }

        public void Pop()
        {
            this._current = this._parents.Pop();
        }
        #endregion
    }
}
