using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace o2Mate
{
    [Guid("E2CA779C-F153-4b4d-9FA2-B206D7838B0C")]
    [CoClass(typeof(ILocaleGroup))]
    [InterfaceType(ComInterfaceType.InterfaceIsIDispatch)]
    [ComVisible(true)]
    public interface ILocaleGroup
    {
        bool ExtractGroupAndName(string text, out string groupName, out string name);
        bool Exists(string name);
        void Create(string name);
        void Remove(string name);
        ILocaleSet Get(string name);
        string Groups { get; }
    }

    [ClassInterface(ClassInterfaceType.None)]
    public class LocaleGroup : ILocaleGroup
    {
        #region ILocaleGroup Membres

        public bool ExtractGroupAndName(string text, out string groupName, out string name)
        {
            groupName = "";
            name = "";
            bool result = false;
            try
            {
                string[] split = text.Split('.');
                if (split.Length > 1)
                {
                    LocaleSystem.ValidateGroupName(split[0]);
                    LocaleElement.ValidateName(String.Join(".", split, 1, split.Length - 1));
                    groupName = split[0];
                    name = String.Join(".", split, 1, split.Length - 1);
                    result = true;
                }
            }
            catch { }
            return result;
        }

        public bool Exists(string name)
        {
            return false;
        }

        public void Create(string name)
        {
            LocaleSystem.CreateGroup(name);
        }

        public void Remove(string name)
        {
            LocaleSystem.DeleteGroup(name);
        }

        public ILocaleSet Get(string name)
        {
            return LocaleSystem.GetSet(name);
        }

        public string Groups
        {
            get
            {
                List<string> groups = LocaleSystem.GetGroups();
                string output = String.Empty;
                foreach (string s in groups)
                {
                    output += " " + s;
                }
                return output.Substring(1);
            }
        }

        #endregion
    }
}
