using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace o2Mate
{
    [Guid("CA901DF6-4ACC-48b6-8B1A-54406322EE54")]
    [CoClass(typeof(IVersion))]
    [InterfaceType(ComInterfaceType.InterfaceIsIDispatch)]
    public interface IVersion
    {
        string CurrentVersion { get; }
    }

    public class VersionNumber
    {
        private int major, minor;

        public int Major
        {
            get { return this.major; }
        }

        public int Minor
        {
            get { return this.minor; }
        }

        public VersionNumber(int major, int minor)
        {
            this.major = major;
            this.minor = minor;
        }
    }

    public class Version : IVersion
    {
        public static string Version_1_0 = "1.0";
        public static string Version_1_1 = "1.1";
        public static string Version_1_2 = "1.2";
        public static VersionNumber VersionNumber = new VersionNumber(1,2);

        public string CurrentVersion
        {
            get { return "Version : " + Version.Version_1_2; }
        }
    }
}
